program Gauss;

{ $BOOTRST $01C00}         {Reset Jump to $01C00}
{$NOSHADOW}
{ $W+ Warnings}            {Warnings off}

Device = mega128, VCC = 5;

Import SysTick;

>From System Import Float;

Define
  ProcClock      = 6000000;        {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0064, iData;
  FrameSize      = $0064, iData;
Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type

{--------------------------------------------------------------}
{ Const Declarations }

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
Var
Eingabe_Matrix : Array[1..5, 1..5] of Float;
Ausgabe_Matrix : Array[1..5] of Float;

{--------------------------------------------------------------}
{ functions }

Procedure Gauss;
Var
  i, j, k        : Byte;
begin
// ----------------------------- Elimination ------------------------------
For k := 5 downto 2 do
    For i := 1 to k-1 do
       Ausgabe_Matrix[i] := Ausgabe_Matrix[i] - Ausgabe_Matrix[k] * Eingabe_Matrix[i,k] / Eingabe_Matrix [k,k];
         For j := 1 to k - 1 do
            Eingabe_Matrix[i,j] := Eingabe_Matrix[i,j] - Eingabe_Matrix[i,k] * Eingabe_Matrix[k,j]/Eingabe_Matrix[k,k];
         End_For;
    End_For;
End_For;
// ----------------------------- Rcksubstitution -------------------------
For i := 1 to 5 do
    For j := 1 to i - 1 do
        Ausgabe_Matrix[i] := Ausgabe_Matrix[i] -  Ausgabe_Matrix[j] * Eingabe_Matrix[i,j];
    End_For;
    Ausgabe_Matrix[i] := Ausgabe_Matrix[i] / Eingabe_Matrix[i,i];
end_For;
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  EnableInts;

// --------------------------- Eingabe_Matrix mit Gleichung belegen -----------------------

// 3X1 + 2X2 + 2X3 - 2 X4 = 8
Eingabe_Matrix[1,1] := 3;
Eingabe_Matrix[1,2] := 2;
Eingabe_Matrix[1,3] := 2;
Eingabe_Matrix[1,4] := -2;
Eingabe_Matrix[1,5] := 0;
Ausgabe_Matrix[1] := -8;


// X1 - X2 - X3 + X5 = -2
Eingabe_Matrix[2,1] := 1;
Eingabe_Matrix[2,2] := -1;
Eingabe_Matrix[2,3] := -1;
Eingabe_Matrix[2,4] := 0;
Eingabe_Matrix[2,5] := 1;
Ausgabe_Matrix[2] := -2;

// 2X1 + 2X3 + X4 - X5 = 4
Eingabe_Matrix[3,1] := 2;
Eingabe_Matrix[3,2] := 0;
Eingabe_Matrix[3,3] := 2;
Eingabe_Matrix[3,4] := 1;
Eingabe_Matrix[3,5] := -1;
Ausgabe_Matrix[3] := 4;

// -X1 + X2 + X3 + X4 + X5 = 2
Eingabe_Matrix[4,1] := -1;
Eingabe_Matrix[4,2] := 1;
Eingabe_Matrix[4,3] := 1;
Eingabe_Matrix[4,4] := 1;
Eingabe_Matrix[4,5] := 1;
Ausgabe_Matrix[4] := 2;

// 2X2 + X4 + 2X5 = 2
Eingabe_Matrix[5,1] := 0;
Eingabe_Matrix[5,2] := 2;
Eingabe_Matrix[5,3] := 0;
Eingabe_Matrix[5,4] := 1;
Eingabe_Matrix[5,5] := 2;
Ausgabe_Matrix[5] := 2;

Gauss;

//-------------------- Lsung --------------------------------

// 0 = Ausgabe_Matrix[1]   (X1)
// 1 = Ausgabe_Matrix[2]   (X2)
// -1= Ausgabe_Matrix[3]   (X3)
// 4 = Ausgabe_Matrix[4]   (X4)
// -2= Ausgabe_Matrix[5]   (X5)


  loop


  endloop;
end Gauss.


